//+------------------------------------------------------------------+
//|                                            Repeated median slope |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  Magenta
#property indicator_width1  2
#property indicator_width2  2

//
//
//
//
//

extern int Price  = PRICE_CLOSE;
extern int Length = 200;
extern int Anchor = 0;

//
//
//
//
//

double values[];
double rrme[];
double rrmr[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
      SetIndexBuffer(0, rrme);
      SetIndexBuffer(1, rrmr);
      SetIndexBuffer(2, values);
   IndicatorShortName("Repeated median line ("+Length+")");      
   return (0);
}
int deinit() { return (0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double worksFull[];
double worksTemp[];
double workiFull[];
double workiTemp[];

//
//
//
//
//

int start()
{
   int limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArraySize(worksFull)!=Length)
           {
               ArrayResize(worksFull,Length);
               ArrayResize(worksTemp,Length-1);
               ArrayResize(workiFull,Length);
               ArrayResize(workiTemp,Length-1);
           }               

   //
   //
   //
   //
   //
   
      for (int i = limit; i >= 0; i--)  values[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      for (int j = 0; j<Length; j++)
      {
            int c = 0;
            for (int k=0; k<Length; k++)
            {
               if (k==j) continue;
                  worksTemp[c] = (  values[Anchor+k]-  values[Anchor+j])/(j-k);
                  workiTemp[c] = (j*values[Anchor+k]-k*values[Anchor+j])/(j-k);
               c++;
            }
            
            //
            //
            //
            //
            //
            
            ArraySort(worksTemp);
            ArraySort(workiTemp);
               double index = (Length-2)/2.0;
               int    ind   = index;
               if (ind == NormalizeDouble(index,5))
                  {
                     worksFull[j] = worksTemp[ind];
                     workiFull[j] = workiTemp[ind];
                  }                        
               else  
                  {
                     worksFull[j] = worksTemp[ind]/2.0+worksTemp[ind+1]/2.0;
                     workiFull[j] = workiTemp[ind]/2.0+workiTemp[ind+1]/2.0;
                  }                     
      }

      //
      //
      //
      //
      //
                  
      ArraySort(worksFull);
      ArraySort(workiFull);
            index = (Length-1)/2.0;
            ind   = index;
            if (ind == NormalizeDouble(index,5))
               {
                  double slope     = worksFull[ind];
                  double intercept = workiFull[ind];
               }                  
            else
               {
                  slope     = worksFull[ind]/2.0+worksFull[ind+1]/2.0;
                  intercept = workiFull[ind]/2.0+workiFull[ind+1]/2.0;
               }                  
            
         //
         //
         //
         //
         //
         
                        
      for (k=0; k< Length; k++) rrme[k+Anchor] = intercept-slope*k;
      for (k=0; k<=Anchor; k++) rrmr[Anchor-k] = intercept+slope*k;
      SetIndexDrawBegin(0,Bars-Length-Anchor+1);
      SetIndexDrawBegin(1,Bars-Anchor-1);

   //
   //
   //
   //
   //
   
   return (0);
}